if(!dojo._hasResource["dojox.gfx.matrix"]){dojo._hasResource["dojox.gfx.matrix"]=true;
dojo.provide("dojox.gfx.matrix");
(function(){var B=dojox.gfx.matrix;
B._degToRad=function(A){return Math.PI*A/180
};
B._radToDeg=function(A){return A/Math.PI*180
};
B.Matrix2D=function(J){if(J){if(typeof J=="number"){this.xx=this.yy=J
}else{if(J instanceof Array){if(J.length>0){var H=B.normalize(J[0]);
for(var G=1;
G<J.length;
++G){var I=H,A=dojox.gfx.matrix.normalize(J[G]);
H=new B.Matrix2D();
H.xx=I.xx*A.xx+I.xy*A.yx;
H.xy=I.xx*A.xy+I.xy*A.yy;
H.yx=I.yx*A.xx+I.yy*A.yx;
H.yy=I.yx*A.xy+I.yy*A.yy;
H.dx=I.xx*A.dx+I.xy*A.dy+I.dx;
H.dy=I.yx*A.dx+I.yy*A.dy+I.dy
}dojo.mixin(this,H)
}}else{dojo.mixin(this,J)
}}}};
dojo.extend(B.Matrix2D,{xx:1,xy:0,yx:0,yy:1,dx:0,dy:0});
dojo.mixin(B,{identity:new B.Matrix2D(),flipX:new B.Matrix2D({xx:-1}),flipY:new B.Matrix2D({yy:-1}),flipXY:new B.Matrix2D({xx:-1,yy:-1}),translate:function(D,A){if(arguments.length>1){return new B.Matrix2D({dx:D,dy:A})
}return new B.Matrix2D({dx:D.x,dy:D.y})
},scale:function(D,A){if(arguments.length>1){return new B.Matrix2D({xx:D,yy:A})
}if(typeof D=="number"){return new B.Matrix2D({xx:D,yy:D})
}return new B.Matrix2D({xx:D.x,yy:D.y})
},rotate:function(F){var E=Math.cos(F);
var A=Math.sin(F);
return new B.Matrix2D({xx:E,xy:-A,yx:A,yy:E})
},rotateg:function(A){return B.rotate(B._degToRad(A))
},skewX:function(A){return new B.Matrix2D({xy:-Math.tan(A)})
},skewXg:function(A){return B.skewX(B._degToRad(A))
},skewY:function(A){return new B.Matrix2D({yx:Math.tan(A)})
},skewYg:function(A){return B.skewY(B._degToRad(A))
},reflect:function(J,K){if(arguments.length==1){K=J.y;
J=J.x
}var A=J*J,I=K*K,H=A+I,L=2*J*K/H;
return new B.Matrix2D({xx:2*A/H-1,xy:L,yx:L,yy:2*I/H-1})
},project:function(J,K){if(arguments.length==1){K=J.y;
J=J.x
}var A=J*J,I=K*K,H=A+I,L=J*K/H;
return new B.Matrix2D({xx:A/H,xy:L,yx:L,yy:I/H})
},normalize:function(A){return(A instanceof B.Matrix2D)?A:new B.Matrix2D(A)
},clone:function(A){var E=new B.Matrix2D();
for(var F in A){if(typeof (A[F])=="number"&&typeof (E[F])=="number"&&E[F]!=A[F]){E[F]=A[F]
}}return E
},invert:function(A){var D=B.normalize(A),F=D.xx*D.yy-D.xy*D.yx,D=new B.Matrix2D({xx:D.yy/F,xy:-D.xy/F,yx:-D.yx/F,yy:D.xx/F,dx:(D.xy*D.dy-D.yy*D.dx)/F,dy:(D.yx*D.dx-D.xx*D.dy)/F});
return D
},_multiplyPoint:function(F,A,E){return{x:F.xx*A+F.xy*E+F.dx,y:F.yx*A+F.yy*E+F.dy}
},multiplyPoint:function(A,F,G){var H=B.normalize(A);
if(typeof F=="number"&&typeof G=="number"){return B._multiplyPoint(H,F,G)
}return B._multiplyPoint(H,F.x,F.y)
},multiply:function(I){var A=B.normalize(I);
for(var H=1;
H<arguments.length;
++H){var J=A,G=B.normalize(arguments[H]);
A=new B.Matrix2D();
A.xx=J.xx*G.xx+J.xy*G.yx;
A.xy=J.xx*G.xy+J.xy*G.yy;
A.yx=J.yx*G.xx+J.yy*G.yx;
A.yy=J.yx*G.xy+J.yy*G.yy;
A.dx=J.xx*G.dx+J.xy*G.dy+J.dx;
A.dy=J.yx*G.dx+J.yy*G.dy+J.dy
}return A
},_sandwich:function(F,A,E){return B.multiply(B.translate(A,E),F,B.translate(-A,-E))
},scaleAt:function(F,G,H,A){switch(arguments.length){case 4:return B._sandwich(B.scale(F,G),H,A);
case 3:if(typeof H=="number"){return B._sandwich(B.scale(F),G,H)
}return B._sandwich(B.scale(F,G),H.x,H.y)
}return B._sandwich(B.scale(F),G.x,G.y)
},rotateAt:function(E,F,A){if(arguments.length>2){return B._sandwich(B.rotate(E),F,A)
}return B._sandwich(B.rotate(E),F.x,F.y)
},rotategAt:function(E,F,A){if(arguments.length>2){return B._sandwich(B.rotateg(E),F,A)
}return B._sandwich(B.rotateg(E),F.x,F.y)
},skewXAt:function(E,F,A){if(arguments.length>2){return B._sandwich(B.skewX(E),F,A)
}return B._sandwich(B.skewX(E),F.x,F.y)
},skewXgAt:function(E,F,A){if(arguments.length>2){return B._sandwich(B.skewXg(E),F,A)
}return B._sandwich(B.skewXg(E),F.x,F.y)
},skewYAt:function(E,F,A){if(arguments.length>2){return B._sandwich(B.skewY(E),F,A)
}return B._sandwich(B.skewY(E),F.x,F.y)
},skewYgAt:function(E,F,A){if(arguments.length>2){return B._sandwich(B.skewYg(E),F,A)
}return B._sandwich(B.skewYg(E),F.x,F.y)
}})
})();
dojox.gfx.Matrix2D=dojox.gfx.matrix.Matrix2D
};