if(!dojo._hasResource["dojox.math.matrix"]){dojo._hasResource["dojox.math.matrix"]=true;
dojo.provide("dojox.math.matrix");
dojo.mixin(dojox.math.matrix,{iDF:0,ALMOST_ZERO:1e-10,multiply:function(P,Q){var O=P.length,N=P[0].length,T=Q.length,R=Q[0].length;
if(N!=T){console.warn("Can't multiply matricies of sizes "+N+","+O+" and "+R+","+T);
return[[0]]
}var S=[];
for(var L=0;
L<O;
L++){S[L]=[];
for(var K=0;
K<R;
K++){S[L][K]=0;
for(var M=0;
M<N;
M++){S[L][K]+=P[L][M]*Q[M][K]
}}}return S
},product:function(){if(arguments.length==0){console.warn("can't multiply 0 matrices!");
return 1
}var D=arguments[0];
for(var C=1;
C<arguments.length;
C++){D=this.multiply(D,arguments[C])
}return D
},sum:function(){if(arguments.length==0){console.warn("can't sum 0 matrices!");
return 0
}var H=this.copy(arguments[0]);
var L=H.length;
if(L==0){console.warn("can't deal with matrices of 0 rows!");
return 0
}var K=H[0].length;
if(K==0){console.warn("can't deal with matrices of 0 cols!");
return 0
}for(var N=1;
N<arguments.length;
++N){var I=arguments[N];
if(I.length!=L||I[0].length!=K){console.warn("can't add matrices of different dimensions: first dimensions were "+L+"x"+K+", current dimensions are "+I.length+"x"+I[0].length);
return 0
}for(var M=0;
M<L;
M++){for(var J=0;
J<K;
J++){H[M][J]+=I[M][J]
}}}return H
},inverse:function(O){if(O.length==1&&O[0].length==1){return[[1/O[0][0]]]
}var P=O.length,I=this.create(P,P),K=this.adjoint(O),L=this.determinant(O),J=0;
if(L==0){console.warn("Determinant Equals 0, Not Invertible.");
return[[0]]
}else{J=1/L
}for(var M=0;
M<P;
M++){for(var N=0;
N<P;
N++){I[M][N]=J*K[M][N]
}}return I
},determinant:function(J){if(J.length!=J[0].length){console.warn("Can't calculate the determinant of a non-squre matrix!");
return 0
}var K=J.length,H=1,L=this.upperTriangle(J);
for(var I=0;
I<K;
I++){var G=L[I][I];
if(Math.abs(G)<this.ALMOST_ZERO){return 0
}H*=G
}H*=this.iDF;
return H
},upperTriangle:function(L){L=this.copy(L);
var T=0,P=0,K=L.length,Q=1;
this.iDF=1;
for(var M=0;
M<K-1;
M++){if(typeof L[M][M]!="number"){console.warn("non-numeric entry found in a numeric matrix: m["+M+"]["+M+"]="+L[M][M])
}Q=1;
var R=0;
while((L[M][M]==0)&&!R){if(M+Q>=K){this.iDF=0;
R=1
}else{for(var N=0;
N<K;
N++){P=L[M][N];
L[M][N]=L[M+Q][N];
L[M+Q][N]=P
}Q++;
this.iDF*=-1
}}for(var O=M+1;
O<K;
O++){if(typeof L[O][M]!="number"){console.warn("non-numeric entry found in a numeric matrix: m["+O+"]["+M+"]="+L[O][M])
}if(typeof L[M][O]!="number"){console.warn("non-numeric entry found in a numeric matrix: m["+M+"]["+O+"]="+L[M][O])
}if(L[M][M]!=0){var T=(-1)*L[O][M]/L[M][M];
for(var S=M;
S<K;
S++){L[O][S]=T*L[M][S]+L[O][S]
}}}}return L
},create:function(J,K,G){G=G||0;
var L=[];
for(var H=0;
H<K;
H++){L[H]=[];
for(var I=0;
I<J;
I++){L[H][I]=G
}}return L
},ones:function(C,D){return this.create(C,D,1)
},zeros:function(C,D){return this.create(C,D)
},identity:function(H,G){G=G||1;
var F=[];
for(var I=0;
I<H;
I++){F[I]=[];
for(var J=0;
J<H;
J++){F[I][J]=(I==J?G:0)
}}return F
},adjoint:function(P){var V=P.length;
if(V<=1){console.warn("Can't find the adjoint of a matrix with a dimension less than 2");
return[[0]]
}if(P.length!=P[0].length){console.warn("Can't find the adjoint of a non-square matrix");
return[[0]]
}var L=this.create(V,V),T=this.create(V-1,V-1);
var O=0,R=0,M=0,N=0,Q=0;
for(var S=0;
S<V;
S++){for(var U=0;
U<V;
U++){M=0;
for(O=0;
O<V;
O++){if(O==S){continue
}N=0;
for(R=0;
R<V;
R++){if(R==U){continue
}T[M][N]=P[O][R];
N++
}M++
}Q=this.determinant(T);
L[S][U]=Math.pow(-1,(S+U))*Q
}}return this.transpose(L)
},transpose:function(E){var F=this.create(E.length,E[0].length);
for(var G=0;
G<E.length;
G++){for(var H=0;
H<E[G].length;
H++){F[H][G]=E[G][H]
}}return F
},format:function(O,N){N=N||5;
function M(C,E){var A=Math.pow(10,E);
var B=Math.round(C*A)/A;
var D=B.toString();
if(D.charAt(0)!="-"){D=" "+D
}if(D.indexOf(".")>-1){D+="."
}while(D.length<E+3){D+="0"
}return D
}var P=O.length;
var K=P>0?O[0].length:0;
var I="";
for(var L=0;
L<P;
L++){I+="| ";
for(var J=0;
J<K;
J++){I+=M(O[L][J],N)+" "
}I+="|\n"
}return I
},copy:function(I){var J=I.length,G=I[0].length,K=this.create(G,J);
for(var H=0;
H<J;
H++){for(var L=0;
L<G;
L++){K[H][L]=I[H][L]
}}return K
},scale:function(J,I){J=this.copy(J);
var K=J.length,G=J[0].length;
for(var H=0;
H<K;
H++){for(var L=0;
L<G;
L++){J[H][L]*=I
}}return J
}})
};