dojo._xdResourceLoaded({depends:[["provide","dojox.math.matrix"]],defineResource:function(B){if(!B._hasResource["dojox.math.matrix"]){B._hasResource["dojox.math.matrix"]=true;
B.provide("dojox.math.matrix");
B.mixin(dojox.math.matrix,{iDF:0,ALMOST_ZERO:1e-10,multiply:function(O,P){var N=O.length,M=O[0].length,S=P.length,Q=P[0].length;
if(M!=S){console.warn("Can't multiply matricies of sizes "+M+","+N+" and "+Q+","+S);
return[[0]]
}var R=[];
for(var A=0;
A<N;
A++){R[A]=[];
for(var T=0;
T<Q;
T++){R[A][T]=0;
for(var L=0;
L<M;
L++){R[A][T]+=O[A][L]*P[L][T]
}}}return R
},product:function(){if(arguments.length==0){console.warn("can't multiply 0 matrices!");
return 1
}var A=arguments[0];
for(var D=1;
D<arguments.length;
D++){A=this.multiply(A,arguments[D])
}return A
},sum:function(){if(arguments.length==0){console.warn("can't sum 0 matrices!");
return 0
}var A=this.copy(arguments[0]);
var M=A.length;
if(M==0){console.warn("can't deal with matrices of 0 rows!");
return 0
}var I=A[0].length;
if(I==0){console.warn("can't deal with matrices of 0 cols!");
return 0
}for(var J=1;
J<arguments.length;
++J){var N=arguments[J];
if(N.length!=M||N[0].length!=I){console.warn("can't add matrices of different dimensions: first dimensions were "+M+"x"+I+", current dimensions are "+N.length+"x"+N[0].length);
return 0
}for(var K=0;
K<M;
K++){for(var L=0;
L<I;
L++){A[K][L]+=N[K][L]
}}}return A
},inverse:function(J){if(J.length==1&&J[0].length==1){return[[1/J[0][0]]]
}var K=J.length,A=this.create(K,K),M=this.adjoint(J),N=this.determinant(J),L=0;
if(N==0){console.warn("Determinant Equals 0, Not Invertible.");
return[[0]]
}else{L=1/N
}for(var O=0;
O<K;
O++){for(var P=0;
P<K;
P++){A[O][P]=L*M[O][P]
}}return A
},determinant:function(J){if(J.length!=J[0].length){console.warn("Can't calculate the determinant of a non-squre matrix!");
return 0
}var K=J.length,H=1,A=this.upperTriangle(J);
for(var I=0;
I<K;
I++){var L=A[I][I];
if(Math.abs(L)<this.ALMOST_ZERO){return 0
}H*=L
}H*=this.iDF;
return H
},upperTriangle:function(A){A=this.copy(A);
var S=0,O=0,T=A.length,P=1;
this.iDF=1;
for(var L=0;
L<T-1;
L++){if(typeof A[L][L]!="number"){console.warn("non-numeric entry found in a numeric matrix: m["+L+"]["+L+"]="+A[L][L])
}P=1;
var Q=0;
while((A[L][L]==0)&&!Q){if(L+P>=T){this.iDF=0;
Q=1
}else{for(var M=0;
M<T;
M++){O=A[L][M];
A[L][M]=A[L+P][M];
A[L+P][M]=O
}P++;
this.iDF*=-1
}}for(var N=L+1;
N<T;
N++){if(typeof A[N][L]!="number"){console.warn("non-numeric entry found in a numeric matrix: m["+N+"]["+L+"]="+A[N][L])
}if(typeof A[L][N]!="number"){console.warn("non-numeric entry found in a numeric matrix: m["+L+"]["+N+"]="+A[L][N])
}if(A[L][L]!=0){var S=(-1)*A[N][L]/A[L][L];
for(var R=L;
R<T;
R++){A[N][R]=S*A[L][R]+A[N][R]
}}}}return A
},create:function(J,K,A){A=A||0;
var H=[];
for(var I=0;
I<K;
I++){H[I]=[];
for(var L=0;
L<J;
L++){H[I][L]=A
}}return H
},ones:function(D,A){return this.create(D,A,1)
},zeros:function(D,A){return this.create(D,A)
},identity:function(G,A){A=A||1;
var J=[];
for(var H=0;
H<G;
H++){J[H]=[];
for(var I=0;
I<G;
I++){J[H][I]=(H==I?A:0)
}}return J
},adjoint:function(P){var V=P.length;
if(V<=1){console.warn("Can't find the adjoint of a matrix with a dimension less than 2");
return[[0]]
}if(P.length!=P[0].length){console.warn("Can't find the adjoint of a non-square matrix");
return[[0]]
}var A=this.create(V,V),T=this.create(V-1,V-1);
var O=0,R=0,M=0,N=0,Q=0;
for(var S=0;
S<V;
S++){for(var U=0;
U<V;
U++){M=0;
for(O=0;
O<V;
O++){if(O==S){continue
}N=0;
for(R=0;
R<V;
R++){if(R==U){continue
}T[M][N]=P[O][R];
N++
}M++
}Q=this.determinant(T);
A[S][U]=Math.pow(-1,(S+U))*Q
}}return this.transpose(A)
},transpose:function(F){var G=this.create(F.length,F[0].length);
for(var H=0;
H<F.length;
H++){for(var A=0;
A<F[H].length;
A++){G[A][H]=F[H][A]
}}return G
},format:function(J,M){M=M||5;
function O(D,F){var G=Math.pow(10,F);
var C=Math.round(D*G)/G;
var E=C.toString();
if(E.charAt(0)!="-"){E=" "+E
}if(E.indexOf(".")>-1){E+="."
}while(E.length<F+3){E+="0"
}return E
}var K=J.length;
var N=K>0?J[0].length:0;
var A="";
for(var P=0;
P<K;
P++){A+="| ";
for(var L=0;
L<N;
L++){A+=O(J[P][L],M)+" "
}A+="|\n"
}return A
},copy:function(I){var J=I.length,A=I[0].length,K=this.create(A,J);
for(var H=0;
H<J;
H++){for(var L=0;
L<A;
L++){K[H][L]=I[H][L]
}}return K
},scale:function(J,I){J=this.copy(J);
var K=J.length,A=J[0].length;
for(var H=0;
H<K;
H++){for(var L=0;
L<A;
L++){J[H][L]*=I
}}return J
}})
}}});